# Create your views here.
from django.template import Context, loader
from django.http import HttpResponse,HttpResponseRedirect
from simono.rtsimple.models import Game, Player,UnitPosition,RtsMap,Unit,UnitKind,Attack,CombatParameter, Factory, FactoryActivation,Chat
import AStar
import time,math,datetime

def login(request):
	# create player if not yet existing
	uname = request.__getitem__("username")
	upwd = request.__getitem__("password")
	pexists = Player.objects.filter(name=uname,password=upwd)
	if len(pexists) :
		request.session["playerid"] = pexists[0].id
	else:
		newp = Player.objects.create(name=uname,password=upwd)
		request.session["playerid"] = newp.id
	return HttpResponseRedirect("/games")

def logout(request):
	request.session["playerid"] = 0
	return HttpResponseRedirect("/games")


def _getplayer(playerid):
	try:
		p = Player.objects.get(id=playerid)
		return p
	except:
		return None

def div_playerlist(request):
	# get the requestin player and save him => for lastaccess
	p = _getplayer(request.session["playerid"])
	if(p):
		p.save()
	onlinep = Player.objects.filter(last__gte = datetime.datetime.fromtimestamp(time.time()-60))
	t = loader.get_template("div_playerlist.html")
	c = Context( {"playerlist": onlinep
				})
	return HttpResponse(t.render(c))


def div_gamelist(request):
	# here we should also mark the players last tick
	# for online player info
	gamelist = Game.objects.all()
	t = loader.get_template('div_gamelist.html')
	c = Context( {
		'gamelist': gamelist
		})
	return HttpResponse(t.render(c))

def div_chatlist(request):
	# get chats from last 5min, newest on top
	chatlines = Chat.objects.filter(timestamp__gte = datetime.datetime.fromtimestamp(time.time()-60*5)).order_by('-timestamp')
	t = loader.get_template("div_chatlist.html")
	c = Context( {
		"chatlist": chatlines
		})
	return HttpResponse(t.render(c))

def chat(request):
	text = request.__getitem__("chatline")
	p = _getplayer(request.session["playerid"])
	if text:
		Chat.objects.create(text=text,player=p)
	t = loader.get_template("div_chatinput.html")
	c = Context({});
	return HttpResponse(t.render(c))

def gamestate(request,gameid):
	lp = _getplayer(request.session["playerid"])
	lgame = Game.objects.get(id=gameid)
	if request.has_key("surrender"):
		# kill all units
		Unit.objects.filter(game__id=gameid,owner=lp).delete()
		Chat.objects.create(player = Player.objects.get(id=4),text=str(lp.name)+" gave up!") # todo: none player
	elif lgame.winner.id == 4:
		# check if we have a winner
		adminUnits = Unit.objects.filter(game=lgame,owner=lgame.admin,health__gt=0)
		if len(adminUnits) <= 0:
			lgame.winner = lgame.player
			Chat.objects.create(player=Player.objects.get(id=4),text=str(lgame.winner.name)+" wins!") # todo: none player
		else:
			playerUnits = Unit.objects.filter(game=lgame,owner=lgame.player,health__gt=0)
			if len(playerUnits) <= 0:
				lgame.winner = lgame.admin
				Chat.objects.create(player=Player.objects.get(id=4),text=str(lgame.winner.name)+" wins!") # todo: none player
		lgame.save()
	if lgame.winner.id != 4: # none player id
		#lgame.delete()
		# delete the game now
		return HttpResponse(str(lgame.winner.id))
	else:
		return HttpResponse(str(-1))


def index(request):

	t = loader.get_template('gamelist.html')
	c = Context({
		'staticurl': "../static",
		'playerid': request.session.get("playerid",0),
		'player': _getplayer(request.session.get("playerid",0)),
		'maplist': RtsMap.objects.all()
	})
	return HttpResponse(t.render(c))


def div_managegame(request):
	lp = _getplayer(request.session["playerid"])
	mygames = Game.objects.filter(admin = lp,winner__id=4) # todo: none player
	# do we want to create a game??
	if request.has_key("gamename") and request.has_key("gamemap"):
		# delete all games the admin was admin so far
		mygames.delete()
		gname = request.__getitem__("gamename")
		mapid = request.__getitem__("gamemap")
		if gname:
			Game.objects.create(admin=lp,
							name = gname,
							RtsMap = RtsMap.objects.get(id=mapid),
							winner = Player.objects.get(id=4), # todo: none player
							player = lp,
							tick = 0,
							started = 0
							)
	# or maybe join a game?
	elif request.has_key("gameid") and request.has_key("join"):
		thegame = Game.objects.get(id=request.__getitem__("gameid"))
		# we can join
		if thegame.player == thegame.admin:
			thegame.player = lp
			thegame.save()
		else:
			pass
		pass
	# or maybe cancel
	elif request.has_key("gameid") and request.has_key("cancel"):
		game = Game.objects.get(id=request.__getitem__("gameid"))
		if game.admin == lp:
			# delete the game
			game.delete()
		else:
			game.player = game.admin
			game.save()
	# or maybe even start the game
	elif request.has_key("gameid") and request.has_key("startgame"):
		game = Game.objects.get(id=request.__getitem__("gameid"))
		game.started = 1
		game.save()
		# redirect to game start screen
		return HttpResponse("/games/run/"+str(request.__getitem__("gameid"))+"/"+str(lp.id)+"/")

	# check wether player is admin somwhere
	mygamesfresh = Game.objects.filter(admin = lp,winner__id=4)
	if( len(mygamesfresh) ):
		players = [mygamesfresh[0].admin, mygamesfresh[0].player]
		c = Context({
			"gamemanager": 1,
			"players": players,
			"game":mygamesfresh[0]
			})
	else:
		# are we player in a game?
		mygamesfresh = Game.objects.filter(player=lp,winner__id=4) # todo: player none
		if len(mygamesfresh):
			# if the game started => redirect to game screen
			if mygamesfresh[0].started:
				gameurl = "/games/run/"+str(mygamesfresh[0].id)+"/"+str(lp.id)+"/";
				return HttpResponse("forwardToUrl('"+gameurl+"');","application/javascript");
			players = [mygamesfresh[0].admin, mygamesfresh[0].player]
			c = Context({
				"gamemanager": 0,
				"players": players,
				"game":mygamesfresh[0]
				})
		else:
			c = Context({
				'gamemanager':0,
				"players":[],
				"game":0,
				'localname':lp.name,
				"maplist": RtsMap.objects.all()
			})
	t = loader.get_template("div_managegame.html")
	return HttpResponse(t.render(c))

def join(request,gameid):
	game = Game.objects.get(id=gameid)

	return HttpResponse("Joining ...")



def loadmap(request,gameid):
    game = Game.objects.get(id=gameid)
    return HttpResponse(str(game.RtsMap.id)+"@/@"+game.RtsMap.data)


def rungame(request,gameid,playerid):
	player = Player.objects.get(id=playerid)
	game = Game.objects.get(id=gameid)
	isadmin = 0
	if player == game.admin:
		game.tick = 0
		game.save()
		isadmin = 1
		# remove all UnitPos for this game
		UnitPosition.objects.filter(unit__game=game).delete()
		# remove all units for this game
		Unit.objects.filter(game=game).delete()
		# remove all factory activations
		FactoryActivation.objects.filter(game=game).delete()
		# remove all attacks
		#Attack.objects.filter(game__id=gameid).delete()
	t = loader.get_template("gamelogic.html")
	c = Context({
		'localplayer': player.name,
		'localplayerid': player.id,
		'gameid':gameid,
		'baseurl':"/",
		'isadmin':isadmin
	})
	return HttpResponse(t.render(c))


def _initunits(game,nodb=0):
	padmin = game.admin
	pother = game.player
	# admin player in top row
	# other player in bottom row
	maph = game.RtsMap.height
	mapw = game.RtsMap.width
	x = math.floor(mapw/2.0 - 2)
	ay = 1
	oy = maph-1
	jstring = ""
	for uk in UnitKind.objects.all(): # DEUBG:
		jstring += _createunit(game,padmin,uk,x,ay,0,nodb)
		jstring += _createunit(game,pother,uk,x,oy,0,nodb)
		x += 1
	return jstring

def _createunit(game,player,kind,x,y,tick,nodb):
	if nodb == 0:
		unit = Unit.objects.create(game=game,owner=player,health=kind.health,kind=kind)
		UnitPosition.objects.create(x=x,y=y,unit=unit,tick=tick)
	return "mygame.createunit("+str(player.id)+","+str(unit.id)+",'"+kind.name+"',"+str(x)+","+str(y)+");\n";

def _getunitstring(unit):
	cpos = UnitPosition.objects.filter(unit=unit,tick__lte=unit.game.tick).order_by('-tick')[0]
	return "mygame.createunit("+str(unit.owner.id)+","+str(unit.id)+",'"+unit.kind.name+"',"+str(cpos.x)+","+str(cpos.y)+");\n";


def unitDist(unit,target):
	upos = UnitPosition.objects.filter(unit=unit,tick__lte=unit.game.tick).order_by('-tick')[0]
	tpos = UnitPosition.objects.filter(unit=target,tick__lte=unit.game.tick).order_by('-tick')[0]
	dist = math.sqrt( math.pow(int(upos.x)-int(tpos.x),2) + math.pow((int(upos.y)-int(tpos.y)),2) )
	return dist


def attackrequest(request,gameid,unitid,targetid):
	unit = Unit.objects.get(id=unitid)
	target = Unit.objects.get(id=targetid)
	# calc dist
	dist = unitDist(unit,target)
	if dist <= 2:
		points = CombatParameter.objects.get(attacker=unit.kind,defender=target.kind).points
		# del all old Attack objects of that unit
		Attack.objects.filter(game=unit.game,attacker=unit).delete()
		Attack.objects.create(game=unit.game,attacker=unit,target=target,attackpoints=points)
	return HttpResponse("okay")

def moverequest(request,gameid,unitid,tilex,tiley):
	game = Game.objects.get(id=gameid)
	unit = Unit.objects.get(id=unitid)
	unitkind = unit.kind
	mapdata = game.RtsMap.data
	maplines = mapdata.split("\n")
	currentpos = UnitPosition.objects.filter(unit__id=unitid,tick__lte=game.tick).order_by('-tick')[0]
	starmap = []
	# weights
	weight = {}
	weight["soldier"] = [-1,1,4,1,0.5,0.5] # todo: this should be in database!!
	weight["tank"] = [-1,1,6,4,0.5,0.5]
	weight["heli"] = [1,1,1,1,1,1]
	weight["flak"] = [-1,1,4,4,0.5,0.5]
	for line in maplines:
		rline = line.rstrip()
		for p in rline:
			starmap.append( weight[unitkind.name][int(p)])

	#return HttpResponse("posx"+str((currentpos.x,currentpos.y))+"  "+str(starmap) + "  width/height"+str( (game.RtsMap.width,game.RtsMap.height)))
	astar = AStar.AStar(AStar.SQ_MapHandler(starmap,game.RtsMap.width,game.RtsMap.height))
	start = AStar.SQ_Location(int(currentpos.x),int(currentpos.y))
	end = AStar.SQ_Location(int(tilex),int(tiley))

	s = time.time()
	p = astar.findPath(start,end)
	e = time.time()
	# write found path info db
	tc = game.tick
	# DELETE all positions from this tick upwards for the unit
	UnitPosition.objects.filter(unit__id=unit.id,tick__gte=tc).delete()
	"""pathlines = []
	pathlines.append( (int(currentpos.x),int(currentpos.y)))
	p = UnitPosition.objects.create(x=int(currentpos.x),
									y=int(currentpos.y),
									tick=tc,
									unit=unit.id)
	"""
	# all points towards dest
	for n in p.nodes:
		tc += unitkind.speed
		p = UnitPosition.objects.create(x=int(n.location.x),
									y=int(n.location.y),
									tick=tc,
									unit=unit)
	# final destination
	p = UnitPosition.objects.create(x=int(tilex),
								y=int(tiley),
								tick=tc+(n.mCost*unitkind.speed),
								unit=unit)
	return HttpResponse("   time="+str(e-s))

"""
def getaliveunits(request,gameid):
	rstring = ""
	game = Game.objects.get(id=gameid)
	for u in Unit.objects.filter(game__id=gameid):
		firstpos = UnitPosition.objects.get(unit = u,tick = 0)
		rstring += "mygame.createunit("+str(u.owner.id)+","+str(u.id)+",'"+u.kind.name+"',"+str(firstpos.x)+","+str(firstpos.y)+");\n";
	# also set the tick timer to something remotly similiar to admins-client!!!
	rstring += "mygame.tick = "+str(int(game.tick)*2)+";\n"
	# create necessary factories
	rstring += _getcurrentfactories(game)
	return HttpResponse(str(rstring),"application/javascript")
"""

def _getcurrentfactories(game,isadmin):
	rstring = ""
	factories = Factory.objects.filter(rtsmap=game.RtsMap)
	for f in factories:
		fas = FactoryActivation.objects.filter(factory=f,game=game)
		owner = -1
		if len(fas):
			owner = fas[0].player.id
			fas0 = fas[0]
			if isadmin == 1 and (fas0.tick <= game.tick):
				# reset tick and produce a unit in front of the factory (+1 x)
				fas0.tick = int(game.tick) + int(f.tickduration)
				fas0.save()
				# player max unit count reached?
				if len(Unit.objects.filter(game=game,owner=fas0.player)) < 16:
					py = f.y+1
					if f.y > game.RtsMap.height/2.:
						py = f.y -1
					_createunit(game,fas0.player,f.unitkind,f.x,py,game.tick,0)
		rstring += "mygame.addfactory("+str(int(f.id))+","+str(owner)+",'"+f.unitkind.name+"',"+str(f.x)+","+str(f.y)+");\n"
	return rstring

def createunit(request,unitid):
	return HttpResponse(str(_getunitstring( Unit.objects.get(id=unitid))),"application/javascript")

def tick(request,gameid,playerid):
	# everytime the admin request a tick, we advance
	# the game on tick
	rstring = "" # return string, contains JS only
	game = Game.objects.get(id=gameid)
	# if its first tick and admin players turn, return the created units
	if (int(game.tick) == 0) and (int(playerid) == int(game.admin.id)):
		#rstring +=
		_initunits(game,0)
		rstring += _getcurrentfactories(game,1)

	# get all units
	units = Unit.objects.filter(game=game)
	unitposition = {}
	# all factories for this map
	factories = Factory.objects.filter(rtsmap=game.RtsMap)
	##print "facs "+str((factories[0].x,factories[0].y))
	# current movetos
	for u in units:
		nextpos = UnitPosition.objects.filter(unit=u,tick__gt=game.tick).order_by('tick')
		if len(nextpos):
			np = nextpos[0]
			rstring += "positions["+str(u.id)+"] = Array("+str(int(np.tick))+","+str(np.x)+","+str(np.y)+");\n";
		# every unit has a currpos!
		currpos = UnitPosition.objects.filter(unit=u,tick__lte=game.tick).order_by('-tick')[0]
		##print str( (currpos.x,currpos.y))
		# nur bei admin pruefen
		if int(playerid) == int(game.admin.id):
			# factory takeovers
			# werden uebernommen wenn eine aktuellste position mit factory uebereinstimmt
			for f in factories:
				if abs(f.x - currpos.x) < 2 and abs(f.y - currpos.y) < 2:
					fasany= FactoryActivation.objects.filter(factory=f,game=game)
					if len(fasany) > 0 and (fasany[0].player == u.owner):
						# do nothing
						pass
					else:
						fasany.delete()
						fact = FactoryActivation.objects.create(tick=int(game.tick)+(f.tickduration),
									factory=f,
									game=game,
									player= u.owner)

	# always send a list of units.. the non-admin client
	# must check for new units and request create updates
	afteru = Unit.objects.filter(game=game)
	ulist = "mygame.unitlist = Array("
	i = 0
	for u in afteru:
		if i != 0:
			ulist += ","
		ulist += str(u.id)
		i += 1
	ulist += ");\n";
	rstring += ulist

	# only admin ticks progress the game!!
	if int(playerid) == int(game.admin.id):
		game.tick += 1
		game.save()



	# current attacks
	attacks = Attack.objects.filter(game__id = gameid)
	for a in attacks:
		if unitDist(a.attacker,a.target) <= 2:
			# nur admin changes params
			if int(playerid) == int(game.admin.id):
				a.target.health -= a.attackpoints
			a.target.save()
			# REMOVE dead units!!
			if a.target.health > 0:
				rstring += "mygame.createattack("+str(a.attacker.id)+","+str(a.target.id)+");\n"
				rstring += "mygame.updatehealth("+str(a.target.id)+","+str(a.target.health)+");\n"
			else:
				#rstring += "mygame.removeunit("+str(a.target.id)+");\n"
				Unit.objects.get(id=a.target.id).delete()
		else:
			a.delete()
	# current factory stuff
	rstring += _getcurrentfactories(game,(int(playerid) == int(game.admin.id)))
	rstring += "mygame.tick = "+str(int((game.tick*2)))+";"
	return HttpResponse(str(rstring),"application/javascript")








